;*******************   Amlioration par rapport a la dernire version :   ********************
;***  Gestion du clavier autonome
;***    => desactivation des interruptions

 xdef _main
 xdef _comment
 xdef _ti89
 xdef _ti92plus
 include doorsos.h
 include util.h
 include hexlib.h

;***  Sous-programmes "fait-maison" :
 include key.h
 include routines.h
 include calc3d.h
 include bres.h
 include tpoly7.h
 include vscreen.h
 include render.h

; xdef _nostub

;***  constantes:

;*************************************************************************************
;********************   MACROS  POUR tpoly :   ***************************************
;*************************************************************************************

;*************************************************************************************
;********************   CONSTANTES  :   **********************************************
;*************************************************************************************

;*****************************************************************************************************************************
;*****************************************************************************************************************************
;                  M       M       A       I I I I I   N        N                                                             
;                  M M   M M      A A          I       N N      N                                                             
;                  M   M   M     A   A         I       N   N    N                                                             
;                  M       M    A A A A        I       N    N   N                                                             
;                  M       M   A       A       I       N      N N                                                             
;                  M       M  A         A  I I I I I   N        N                                                             
;*****************************************************************************************************************************
;*****************************************************************************************************************************
_main:
; jmp _main

; clear_interrupts
;boucle:
; get_key
; lea keystat,a0
; print_hex (a0),0,0
; print_hex 4(a0),1,0
; print_hex 8(a0),2,0

; test_esc
; jmp boucle
; rts

; jmp _main

; move.l #LCD_MEM,adresse_de_l_ecran_virtuel

; move.w #1,d0
; move.w #1,d1
; move.w #1,d2
; move.w #101,d3
; bsr bline

; bsr draw_lined_polygon

;bid:
; jmp bid

; print_hex d0,0,0
; break aa
; rts

; bset.b  #5,flag           ;pas de fichier choisi pour l'instant
; bsr Menu

; lea 3(a0),a0              ;on se positionne au dbut du fichier texte

debut:

 clear_interrupts

 move.l #0,rx
 move.l #0,ry
 move.l #0,rz

 move.w #250,sx
 move.w #250,sy
 move.w #250,sz

 move.b #%00000001,render

;********************************************************************************************
;*********   Alloue de la mmoire    ************
;********************************************************************************************
 load_calc_3d len_pts
 load_vscreen

retrace:

;***  on efface l'cran virtuel:
 clr_vscreen

;***  Calcul 3d
 init_nx

 projection_plane

;******************************************************************************************
;*************************   DRAW WORLD ***************************************************
;******************************************************************************************

 draw_lines
 draw_surfaces
 draw_textures


trace:
 show_vscreen

;******************************************************************************************
;***************************   Teste les touches   ****************************************
;******************************************************************************************
key:

 get_key

;Touche Esc ?
 test_esc
 beq delbloc_et_fin

;Touches flches ? (rotation)
 test_up
 bne no_up
 moveq.l #0,d0
 move.b render,d0
 add.l d0,rx
no_up:
 test_down
 bne no_down
 moveq.l #0,d0
 move.b render,d0
 sub.l d0,rx
no_down:
 test_left
 bne no_left
 moveq.l #0,d0
 move.b render,d0
 sub.l d0,ry
no_left:
 test_right
 bne no_right
 moveq.l #0,d0
 move.b render,d0
 add.l d0,ry
no_right:

;***  Modifie le grossissement
 test_moins
 bne no_moins
 subi.w #5,sx
 subi.w #5,sy
no_moins:
 test_plus
 bne no_plus
 addi.w #5,sx
 addi.w #5,sy
no_plus:

;***  Modifie l'angle de fuite
 test_mul
 bne no_mul
 addi.w #10,sz
no_mul:
 test_div
 bne no_div
 subi.w #10,sz
no_div:

;***  Changement de rendu
 test_f1
 bne no_f1
 move.b #%00000001,render
no_f1:
 test_f2
 bne no_f2
 move.b #%00000010,render
no_f2:
 test_f3
 bne no_f3
 move.b #%00000100,render
no_f3:

 jmp retrace

;********************************************************************************************
;***************************   Supprime le bloc mmoire   ***********************************
;********************************************************************************************
delbloc_et_fin:

 unload_calc_3d
 unload_vscreen

 restore_interrupts

 rts

mapping:
;       dc.w 0,0,0,16,16,0,16,0,0,16,16,16
;       dc.w 0,0,0,16,16,0,16,0,0,16,16,16
;       dc.w 0,0,0,16,16,0,16,0,0,16,16,16
;       dc.w 0,0,0,16,16,0,16,0,0,16,16,16
;       dc.w 0,0,0,16,16,0,16,0,0,16,16,16
;       dc.w 0,0,0,16,16,0,16,0,0,16,16,16
       dc.w 0,0,0,16,16,16,16,0
       dc.w 0,0,0,16,16,16,16,0
       dc.w 0,0,0,16,16,16,16,0
       dc.w 0,0,0,16,16,16,16,0
       dc.w 0,0,0,16,16,16,16,0
       dc.w 0,0,0,16,16,16,16,0

polygone: dc.w 3                  ;nbre de points qui dfinissent le polygone
          dc.w 50,50,50,50,100,50,160,1
          dc.w 150,0
          dc.w 50,0,0,0,0,0,0,0,0,0,0,0,0

coordonnees_de_mapping:
          dc.w 0,0,0,16,16,16,16,0
          dc.w 0,0

largeur_de_l_image EQU 16

len_pts: dc.l 8           ;7+1 pts au total (7 est le nbre d'itrations)
pts:   dc.l 10,10,10
       dc.l 10,10,-10
       dc.l -10,10,-10
       dc.l -10,10,10
       dc.l 10,-10,10
       dc.l 10,-10,-10
       dc.l -10,-10,-10
       dc.l -10,-10,10

connect:
         dc.b 0,1,1,2,2,3,3,0,0,4,4,5,5,6,6,7,7,4,7,3,1,5,6,2
         dc.b $FF
         dc.b 0,2,3,5,0,6,7,5,2,6,6,5,2,4
         dc.b $FF
;connect: dc.b $FF             ;format DOS: on finit par le caractre $FF

textures:                         ;dclare une texture: nbre de pts  relier,liste de pts  relier
;       dc.b $FF
;       dc.b 3,3,7,0,3,0,7,4
;       dc.b 3,0,4,1,3,1,4,5
;       dc.b 3,1,5,2,3,2,5,6
;       dc.b 3,2,6,3,3,3,6,7
;       dc.b 3,2,3,1,3,1,3,0
;       dc.b 3,7,6,4,3,4,6,5
       dc.b 4,0,4,5,1
       dc.b 4,1,5,6,2
       dc.b 4,2,3,0,1
       dc.b 4,7,6,5,4
       dc.b 4,2,6,7,3
       dc.b 4,3,7,4,0
       dc.b $FF                ;fin de dclaration

image:
       dc.b 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
       dc.b 1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       dc.b 1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1
       dc.b 1,0,0,0,0,1,0,0,0,0,0,1,0,0,0,1
       dc.b 1,0,0,0,1,0,0,0,0,0,0,0,1,0,0,1
       dc.b 1,0,0,1,0,0,1,1,0,1,0,0,1,0,0,1
       dc.b 1,0,0,1,0,1,0,0,1,1,0,0,0,1,0,1
       dc.b 1,0,0,1,0,1,0,0,0,1,0,0,0,1,0,1
       dc.b 1,0,0,1,0,1,0,0,0,1,0,0,0,1,0,1
       dc.b 1,0,0,1,0,0,1,0,1,1,0,0,1,0,0,1
       dc.b 1,0,0,1,0,0,0,1,0,1,0,1,1,0,0,1
       dc.b 1,0,0,0,1,0,0,0,0,0,1,1,0,0,0,1
       dc.b 1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1
       dc.b 1,0,0,0,0,0,1,1,1,1,1,0,0,0,0,1
       dc.b 1,1,0,0,0,0,0,0,0,0,0,0,0,0,1,1
       dc.b 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1

       dc.b 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
;       dc.b 0,0,0,0,0,0,0,0 ,0,0,0,0,0,0,0,0

render: dc.b 0

_comment:   dc.b "Gestion 3D",0
            end
